/*
 * Tool name   : SelfDelete
 * Description : This is a proof of concept tool to show how to make a 
 *               process delete its own binary file. Normally an exe file
 *               can't delete itself because the file was locked when it 
 *               was executed and still running. There are several ways to 
 *               handle this. This solution solves this problem programmatically 
 *               inside the calling program itself without incorporating external
 *               resources like a batch script.
 * Author      : carrumba
 * Webpage     : http://www.megapanzer.com
 * Version     : 0.1
 * OS          : Tested on Microsoft Windows XP
 * Todo        : -
 *
 * Changes     : - 
 * 
 *
 *
 *
 * License     :
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include <windows.h>
#include <stdio.h>

#define MAX_BUF_SIZE 1024

#pragma comment(lib, "shell32.lib")


/*
 * Constants, data types and function forward declarations.
 *
 */


void deleteYourself();



int main()
{
  int lRetVal = 0;

  deleteYourself();

  exit(lRetVal);
}


void deleteYourself()
{
  char lCommand[MAX_BUF_SIZE + 1];
  char lFile[MAX_BUF_SIZE + 1];


  ZeroMemory(lCommand, sizeof(lCommand));

  if((GetModuleFileName(0, lFile, sizeof(lFile)) != 0) && (GetShortPathName(lFile, lFile, MAX_BUF_SIZE) != 0))
  {
    _snprintf(lCommand, sizeof(lCommand) - 1, "/c del %s >> NUL", lFile);
    GetEnvironmentVariable("ComSpec", lFile, MAX_PATH) && ShellExecute(0, 0, lFile, lCommand, 0, SW_HIDE);
  }// else
}